#ifndef THREADBINARYTREE_H_
#define THREADBINARYTREE_H_

//
// Include the C standard library header file here
//

#include <stdio.h>

//
// Other header files are included here
//

#include "Stack.h"

//
// Define the data structure here
//

#define MAX_STRING_SIZE 20	// The size of the string storage space

typedef char ElemType;
typedef unsigned int PtrTag;

typedef struct _BiThrNode
{
	ElemType data;				// Binary tree node data
	struct _BiThrNode* lchild;	// Left child pointer
	struct _BiThrNode* rchild;	// Right child pointer
	PtrTag ltag, rtag;			// Left and right identification fields
}BiThrNode, *PBiThrTree;


//
// Declare the function here
//

BiThrNode* CreateNode(ElemType data);
PBiThrTree InitTree();
int InOrderThreading(PBiThrTree pHead, PBiThrTree pTree); 

void OutputResult(PBiThrTree pHead, PBiThrTree pTree); 

//
// Declare global variables here
//

extern Stack stack;

#endif /* THREADBINARYTREE_H_ */
