﻿# 阅读实验源代码
**main.c文件**  
在main函数中首先创建了一棵二叉树，然后调用函数InOrderThreading对二叉树进行线索化。  
在main函数的后面，定义了函数InOrderThreading， 此函数的函数体还不完整，留给读者完成。  
**ThreadBinaryTree.h文件**  
定义了与线索二叉树相关的数据结构并声明了相关的操作函数和全局变量。注意，此头文件中还包含了栈模块的头文件Stack.h。  
**Stack.h文件**   
定义了与栈相关的数据结构并声明了相关的操作函数。  
**Stack.c文件**  
定义了与栈相关的操作函数。  
# 在演示模式下调试项目
**按照下面的步骤调试项目：**
1.	按F7生成项目。
2.	在演示模式下，按F5启动调试项目。程序会在观察点函数的开始位置中断。
3.	重复按F5，直到调试过程结束。

在调试的过程中，每执行“演示流程”窗口中的一行后，仔细观察“可视化数据”窗口内容所发生的变化，理解二叉树线索化的执行过程。“可视化数据”窗口显示的数据信息（如下图所示），包括：
-	头结点的详细信息。包括结点地址及前驱后继的指向。   
-	二叉树的详细信息。  
a)	二叉树节点的值和地址。  
b)	使用指针指向了该结点的左孩子和右孩子。  
c)	在栈中的结点的填充色为绿色。  
d)	用蓝色带箭头的虚线表示出了二叉树的线索。  
e)	pPre游标指向了刚刚访问过的结点，pNode游标指向了当前的结点。  
-	线索化二叉树时使用的栈。显示了已入栈的二叉树节点的地址、值（空地址的值会被忽略）。  

![线索二叉树](./img/12.png)

# 编写源代码并通过验证
**按照下面的步骤继续实验：**
1.	为InOrderThreading函数编写源代码。注意，尽量不要使用递归算法，而是使用栈来保存还未线索化的子树的根结点，并尽量使用已定义的局部变量。
2.	按F7生成项目。如果生成失败，根据“输出”窗口中的提示信息修改源代码中的语法错误。
3.	按Alt+F5启动验证。如果验证失败，可以使用“输出”窗口中的“比较”功能，或者在“非演示模式”下按F5启动调试后重复按F10单步调试读者编写的源代码，从而定位错误的位置，然后回到步骤1。

# 教师参考答案
请教师用户首先访问[教师项目群组](https://www.codecode.net/engintime/ds-lab/teachers-packet),申请权限并审核通过后，再[domain relative url](engintime/ds-lab/teachers-packet/Lab012.git)访问本项目的参考答案